function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/**
 * Given a path array return a path string
 * @param path - the path array comprising of string and number parts
 */
function formatPath(path) {
  return path.map(function (part) {
    return typeof part === 'string' ? ".".concat(part) : "[".concat(part, "]");
  }).reduce(function (l, r) {
    return l + r;
  }, '$');
}
/**
 * Determine the printed string for a value
 * @param value - a value to print
 */

function displayValue(value) {
  if (value === null) {
    return 'null';
  }

  if (value === undefined) {
    return 'undefined';
  }

  switch (_typeof(value)) {
    case 'string':
    case 'number':
    case 'boolean':
    case 'bigint':
      return JSON.stringify(value);

    case 'symbol':
      return "@@".concat(value.toString());

    case 'object':
      if (Array.isArray(value)) {
        return "[".concat(value.map(function (v) {
          return displayValue(v);
        }).join(', '), "]");
      }

      return "{".concat(Object.keys(value).map(function (key) {
        return "".concat(key, ": ").concat(displayValue(value[key]));
      }).join(', '), "}");

    default:
      return _typeof(value);
  }
}

/**
 * Converter Errors are the standard errors
 * coming from type-converters
 */

var ConverterError = /*#__PURE__*/function (_Error) {
  _inherits(ConverterError, _Error);

  var _super = _createSuper(ConverterError);

  /**
   * Error Fields records the path to fields that have an error.
   * The key of the errorFields is a path in the form of $.part[index]
   */
  function ConverterError(actual, expected, path) {
    var _this;

    _classCallCheck(this, ConverterError);

    _this = _super.call(this, "At Path ".concat(formatPath(path), ", expected ").concat(expected, " but was ").concat(displayValue(actual)));

    _defineProperty(_assertThisInitialized(_this), "errorFields", void 0);

    _this.name = 'ConverterError';
    _this.errorFields = _defineProperty({}, formatPath(path), {
      expected: expected,
      actual: displayValue(actual)
    });
    return _this;
  }

  return ConverterError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

// this avoids complex path parsing while getting a "good enough" hueristic

function guessPathLength(formattedPath) {
  return Array.from(formattedPath).map(function (v) {
    return v === '.' || v === '[' ? 1 : 0;
  }).reduce(function (l, r) {
    return l + r;
  }, 0);
} // find the count of errors at the max depth.


function maxDepthCount(error) {
  return Object.keys(error.errorFields).map(guessPathLength).reduce(function (max, d) {
    if (d === max.depth) {
      max.count += 1;
    } else if (d > max.depth) {
      max.depth = d;
      max.count = 1;
    }

    return max;
  }, {
    depth: 0,
    count: 0
  });
}
/**
 * A Converter Function
 */


/**
 * Given a converter function get the name of the converter
 * @param converter - the converter function
 */
function getConverterName(converter) {
  return converter.displayName || converter.name || 'anonymous';
}
/**
 * Given a converter function or converter extract the result type.
 */

/**
 * Given a converter function and optional name create a converter
 * @param converter - the converter function to use to convert the values
 * @param name - the name, if not specified uses the display name or name property of the converter
 */
function createConverter(converter) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : getConverterName(converter);
  return Object.defineProperties(function (input) {
    var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var entity = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : input;
    return converter(input, path, entity);
  }, {
    displayName: {
      value: name,
      writable: false,
      enumerable: true
    },
    pipe: {
      value: function value(nextConverter) {
        var displayName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "".concat(name, " -> ").concat(getConverterName(nextConverter));
        return createConverter(function (input, path, entity) {
          return nextConverter(converter(input, path, entity), path, entity);
        }, displayName);
      },
      writable: false,
      enumerable: true
    },
    or: {
      value: function value(otherConverter) {
        var joinedName = "".concat(name, " | ").concat(getConverterName(otherConverter));
        return createConverter(function (input, path, entity) {
          try {
            return converter(input, path, entity);
          } catch (err) {
            try {
              return otherConverter(input, path, entity);
            } catch (other) {
              if (err instanceof ConverterError && other instanceof ConverterError) {
                // heuristic to figure out which is the more likely branch
                var errStat = maxDepthCount(err);
                var otherStat = maxDepthCount(other); // if one is able to find errors deeper in the tree it's more likely

                if (errStat.depth > otherStat.depth) {
                  throw err;
                } else if (otherStat.depth > errStat.depth) {
                  throw other; // the one with the most deepest errors is more likely
                } else if (errStat.count > otherStat.count) {
                  throw err;
                } else if (otherStat.count > errStat.count) {
                  throw err;
                } // if both have the same number of errors at the same level create a joined up error:
                // example t.string.or(t.boolean) should be "expected string | boolean but was ..."

              } // throw a joined up error


              throw new ConverterError(input, joinedName, path);
            }
          }
        }, joinedName);
      },
      writable: false,
      enumerable: true
    },
    "default": {
      value: function value(defaultConverter) {
        var defaultedName = "".concat(name, " with default");
        return createConverter(function (input, path, entity) {
          if (input === undefined) {
            input = defaultConverter(undefined, path, entity);
          }

          return converter(input, path, entity);
        }, defaultedName);
      },
      writable: false,
      enumerable: true
    }
  });
}

/**
 * Converts values to numbers
 * This expects incoming values to be numbers or string then
 * calls the Number constructor to try to convert values
 */

var NumberConverter = createConverter(function (value, path) {
  if (typeof value === 'number' || typeof value === 'string') {
    var n = Number(value);

    if (!isNaN(n)) {
      return n;
    }
  }

  throw new ConverterError(value, 'number', path);
}, 'number');
/**
 * Converts defined non-object and non-functions to strings.
 * This calls the String constructor to convert incoming values
 */

var StringConverter = createConverter(function (value, path) {
  if (value === undefined || value === null || _typeof(value) === 'object' || typeof value === 'function') {
    throw new ConverterError(value, 'string', path);
  }

  return String(value);
}, 'string');
/**
 * Converts values to booleans
 * this accepts the string literals of "true" or "false" but otherwise expects a boolean or Boolean
 */

var BooleanConverter = createConverter(function (value, path) {
  if (typeof value === 'boolean') {
    return value;
  }

  if (value instanceof Boolean) {
    return value.valueOf();
  }

  if (value === 'true') {
    return true;
  } else if (value === 'false') {
    return false;
  }

  throw new ConverterError(value, 'boolean', path);
}, 'boolean');
/**
 * Passes through an unknown value unchanged.
 * Useful when used with the record container
 */

var UnknownConverter = createConverter(function (value) {
  return value;
}, 'unknown');
/**
 * Always throws an error no mater what value is passed
 * Useful when dealing with deprecated properties that should not be provided
 */

var NeverConverter = createConverter(function (value, path) {
  throw new ConverterError(value, 'never', path);
}, 'never');
/**
 * Given a value create a converter that must match the literal value
 * @param value - the literal value to compare to, uses === identity equality
 */

function literal(value) {
  var name = displayValue(value);
  return createConverter(function (input, path) {
    if (input === value) {
      return value;
    }

    throw new ConverterError(input, name, path);
  }, name);
}
/**
 * Converter that matches the literal null,
 * You can make values optionally nullable by using
 * t.null.or(...)
 */

var NullConverter = literal(null);
/**
 * Converter that matches the literal undefined,
 * You can make values optionally undefined by using
 * t.undefined.or(...)
 */

var UndefinedConverter = literal(undefined);
/**
 * A type representing undefined or null
 */

/**
 * Converter that matches the literal undefined or null,
 * You can make values optionally none by using
 * t.none.or(...)
 */
var NoneConverter = createConverter(function (value, path) {
  if (value === null) {
    return null;
  }

  if (value === undefined) {
    return undefined;
  }

  throw new ConverterError(value, 'none', path);
}, 'none');

/**
 * A Record\<string,T\> converter
 * @param converter - the converter to use for the values in the record
 */

function record(converter) {
  var name = "Record<string,".concat(getConverterName(converter), ">");
  return createConverter(function (value, path, entity) {
    if (value === null || value === undefined || _typeof(value) !== 'object' || Array.isArray(value)) {
      throw new ConverterError(value, name, path);
    }

    var val = value;
    var errors = [];
    var result = Object.keys(val).map(function (key) {
      var v = val[key];
      var newPath = [].concat(_toConsumableArray(path), [key]);

      try {
        return _defineProperty({}, key, converter(v, newPath, entity));
      } catch (err) {
        if (err instanceof ConverterError) {
          errors.push(err);
        } else {
          errors.push(new ConverterError(v, getConverterName(converter), newPath));
        }

        return {};
      }
    }).reduce(function (acc, obj) {
      return _objectSpread2(_objectSpread2({}, acc), obj);
    }, {});

    if (errors.length > 0) {
      throw errors.reduce(function (l, r) {
        Object.assign(l.errorFields, r.errorFields);
        return l;
      });
    }

    return result;
  }, name);
}
/**
 * A Array\<T\> converter
 * @param converter - the converter to use for values of the array.
 */

function array(converter) {
  var name = "Array<".concat(getConverterName(converter), ">");
  return createConverter(function (value, path, entity) {
    if (!Array.isArray(value)) {
      throw new ConverterError(value, name, path);
    }

    var errors = [];
    var result = value.map(function (v, i) {
      var newPath = [].concat(_toConsumableArray(path), [i]);

      try {
        return converter(v, newPath, entity);
      } catch (err) {
        if (err instanceof ConverterError) {
          errors.push(err);
        } else {
          errors.push(new ConverterError(v, getConverterName(converter), newPath));
        }
      }

      return undefined;
    });

    if (errors.length > 0) {
      throw errors.reduce(function (l, r) {
        Object.assign(l.errorFields, r.errorFields);
        return l;
      });
    }

    return result;
  }, name);
}

/**
 * Given a set of converters if one succeeds at converting the input return the
 * given value.
 *
 * @param converters - Array of converters to pass in.
 * @param value - Value to return
 *
 */

var coerce = function coerce(converters, value) {
  var predicate = converters.reduce(function (c1, c2) {
    return c1.or(c2);
  });
  return predicate.pipe(function () {
    return value;
  }, "".concat(predicate.displayName, " -> ").concat(displayValue(value)));
};
/**
 * A coercer that coerces values of None type to a null literal
 */

var noneAsNull = coerce([NoneConverter], null);
/**
 * A coercer that coerces values of None type to an undefined literal
 */

var noneAsUndefined = coerce([NoneConverter], undefined);

/**
 * Combine an arbitrary number of converters and pass their resulting
 *   values into the `combiner` function.
 *
 * @param converters - Array of converters to pass in.
 * @param combiner - Function to call with the results of all the
 *   converter functions.
 */
var compose = function compose(converters, combiner) {
  return createConverter(function (value, path, entity) {
    var args = Object.values(converters).map(function (c) {
      return c(value, path, entity);
    });
    return combiner.apply(void 0, _toConsumableArray(args));
  }, getConverterName(combiner));
};

/**
 * Given a converter function make an optional converter function
 * Optional functions allow undefined values to pass-through
 * @param converter - the inner converter function
 */

function optional(converter) {
  return createConverter(function (input, path, entity) {
    if (input === undefined) {
      return undefined;
    }

    return converter(input, path, entity);
  }, "optional ".concat(getConverterName(converter)));
}
/**
 * Given a converter function make an noneable converter that allows `none`
 * types to pass through
 * @param converter - the inner converter function
 */

function noneable(converter) {
  return createConverter(function (input, path, entity) {
    if (input === undefined) {
      return undefined;
    }

    if (input === null) {
      return null;
    }

    return converter(input, path, entity);
  }, "optional ".concat(getConverterName(converter)));
}
/**
 * Given a converter function make an noneable converter function that also coerces
 * `none` to `null`
 * @param converter - the inner converter function
 */

function noneableAsNull(converter) {
  return createConverter(function (input, path, entity) {
    if (input === undefined || input === null) {
      return null;
    }

    return converter(input, path, entity);
  }, "optional ".concat(getConverterName(converter)));
}
/**
 * Given a converter function make an noneable converter function that also coerces
 * `none` to `undefined`
 * @param converter - the inner converter function
 */

function noneableAsUndefined(converter) {
  return createConverter(function (input, path, entity) {
    if (input === undefined || input === null) {
      return undefined;
    }

    return converter(input, path, entity);
  }, "optional ".concat(getConverterName(converter)));
}

/**
 * When composing functions it is useful to expose a function that doesn't take additional arguments
 * @param converter - a converter to run on the input
 * @returns a function that passes its first argument only to the converter.
 */
var convert = function convert(converter) {
  return function (input) {
    return converter(input, [], input);
  };
};

/**
 * The ShapeConverter is a converter, however we expose the
 * converters that were used to create it. This allows for these
 * converters to be spread, in order to inherit them.
 */

/**
 * A strict converter where properties not explicitly specified will not be returned
 * @param converters - an object structure describing the resulting value
 */
function strict(converters) {
  var name = "{".concat(Object.keys(converters).map(function (key) {
    return "".concat(key, ": ").concat(getConverterName(converters[key]));
  }).join(', '), "}");
  return Object.defineProperties(createConverter(function (value, path, entity) {
    var v = value === null ? {} : value;

    if (v === undefined || _typeof(v) !== 'object') {
      throw new ConverterError(value, name, path);
    }

    var errors = [];
    var result = Object.keys(converters).map(function (key) {
      var val = v[key];
      var newPath = [].concat(_toConsumableArray(path), [key]);
      var converter = converters[key];

      try {
        return _defineProperty({}, key, converter(val, newPath, entity));
      } catch (err) {
        if (err instanceof ConverterError) {
          errors.push(err);
        } else {
          errors.push(new ConverterError(val, getConverterName(converter), newPath));
        }

        return {};
      }
    }).reduce(function (acc, obj) {
      return _objectSpread2(_objectSpread2({}, acc), obj);
    }, {});

    if (errors.length > 0) {
      throw errors.reduce(function (l, r) {
        Object.assign(l.errorFields, r.errorFields);
        return l;
      });
    }

    return result;
  }, name), {
    converters: {
      enumerable: true,
      value: Object.keys(converters).reduce(function (l, key) {
        return _objectSpread2(_objectSpread2({}, l), {}, _defineProperty({}, key, createConverter(converters[key])));
      }, {}),
      writable: false
    },
    strict: {
      enumerable: true,
      value: true,
      writable: false
    }
  });
}
/**
 * A loose shape converter that allows unknown properties to pass through
 * Generally shape should be used if the value is going to be "re-serialized" as-is
 * This is useful for things like application stacks which may want to verify a subset of
 * properties but leave most validation up to the domain stack
 * @param converters - an object structure describing the resulting value
 */

function shape(converters) {
  var converter = strict(converters);
  return Object.defineProperties(createConverter(function (value, path, entity) {
    var result = converter(value, path, entity); // Find all the missing keys

    var val = value;
    return Object.keys(val).filter(function (key) {
      return !(key in converters);
    }).reduce(function (l, key) {
      return _objectSpread2(_objectSpread2({}, l), {}, _defineProperty({}, key, val[key]));
    }, result);
  }, converter.displayName), {
    converters: {
      value: converter.converters,
      writable: false,
      enumerable: true
    },
    strict: {
      value: false,
      writable: false,
      enumerable: true
    }
  });
}
/**
 * Given a shape converter turns all converters into optionals.
 *
 * If the given shape converter was created with the t.strict creator
 * the resulting partial will also be strict
 * @param converter - the shape converter to make partial
 */

function partial(converter) {
  if (converter.strict) {
    return strict(Object.keys(converter.converters).reduce(function (l, key) {
      return _objectSpread2(_objectSpread2({}, l), {}, _defineProperty({}, key, optional(converter.converters[key])));
    }, {}));
  } else {
    return shape(Object.keys(converter.converters).reduce(function (l, key) {
      return _objectSpread2(_objectSpread2({}, l), {}, _defineProperty({}, key, optional(converter.converters[key])));
    }, {}));
  }
}

var CurrentPath = Symbol('.');
var ParentPath = Symbol('..');

/**
 * Resolves `targetPath` on `entity. Able to support both relative and absolute paths.
 *
 * @param entity - Entity to traverse.
 * @param targetPath - Targeted path to resolve.
 * @param currentPath - Path of the current converter.
 */
var followPath = function followPath(entity, targetPath, currentPath) {
  if (targetPath.length > 0) {
    // Check for relative paths
    switch (targetPath[0]) {
      case CurrentPath:
        // If current, append target path to current path.
        targetPath = [].concat(_toConsumableArray(currentPath), _toConsumableArray(targetPath.slice(1)));
        break;

      case ParentPath:
        // If parent, use currentPath minus one level per '..'.
        var count = targetPath.findIndex(function (part) {
          return part !== ParentPath;
        }, 0);

        if (count === -1) {
          // every item in targetPath is a ParentPath node
          targetPath = currentPath.slice(0, currentPath.length - targetPath.length);
        } else {
          // Otherwise return currentPath and targetPath merged.
          targetPath = [].concat(_toConsumableArray(currentPath.slice(0, currentPath.length - count)), _toConsumableArray(targetPath.slice(count)));
        }

        break;
    }
  }

  return [targetPath.reduce(function (e, part) {
    return e != null ? e[part] : e;
  }, entity), targetPath];
};
/**
 * Given a Path and a converter, invoke the converter at the given path
 * from the root entity.
 *
 * This is especially useful for migrating data from old schemas
 * @param targetPath -the path to pull data from
 */


function forPath(targetPath) {
  var converter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : UnknownConverter;
  return createConverter(function (_, entityPath, entity) {
    var _followPath = followPath(entity, targetPath, entityPath),
        _followPath2 = _slicedToArray(_followPath, 2),
        newEntity = _followPath2[0],
        newTarget = _followPath2[1];

    return converter(newEntity, newTarget, entity);
  }, getConverterName(converter));
}
/**
 * Reroot the given converter at its current point in the tree.
 * This effectively causes functions like forPath to
 * be unable to traverse above the current point in the tree. It's useful as a way
 * to re-use converters when you have nested data.
 * @param converter - the converter to process data with
 */

function sub(converter) {
  return createConverter(function (value, path) {
    var basePath = formatPath(path);

    try {
      // invoke the inner converter resetting path and entity
      return converter(value, [], value);
    } catch (err) {
      if (err instanceof ConverterError) {
        // re-root all the paths
        var errorKeys = Object.keys(err.errorFields);
        errorKeys.forEach(function (key) {
          // get the error
          var error = err.errorFields[key]; // delete the existing error

          delete err.errorFields[key]; // rebuild the root key (excluding the leading $)

          err.errorFields[basePath + key.substr(1)] = error;
        });
      }

      throw err;
    }
  }, getConverterName(converter));
}

/**
 * One of a set of constant types
 * This uses triple equality (===) to compare
 */

function oneOf(options) {
  var name = options.map(function (v) {
    return displayValue(v);
  }).join(' | ');
  return createConverter(function (value, path) {
    if (options.includes(value)) {
      return value;
    }

    throw new ConverterError(value, name, path);
  }, name);
}
/**
 * A union type for tagged unions
 * @param tag - the branch selector selects which union branch to use
 * @param options - the union branches
 */

function taggedUnion(tag, options) {
  var name = "".concat(Object.keys(options).map(function (key) {
    return getConverterName(options[key]);
  }).join(' | '));
  return createConverter(function (value, path, entity) {
    if (value === null || value === undefined || !(tag in value)) {
      throw new ConverterError(value, name, path);
    }

    var v = "".concat(value[tag]);

    if (!(v in options)) {
      throw new ConverterError(value, name, path);
    }

    return options[v](value, path, entity);
  }, name);
}
/**
 * Flattens a converter function that returns a converter function into
 *   just a converter function.
 *
 * @param converter - Converter function to flatten.
 */

var select = function select(converter) {
  return createConverter(function (input) {
    var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var entity = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : input;
    var pick = converter(input, path, entity);
    return pick(input, path, entity);
  });
};

export { ConverterError, CurrentPath, ParentPath, array, BooleanConverter as boolean, coerce, compose, convert, createConverter, displayValue, forPath, formatPath, getConverterName, literal, NeverConverter as never, NoneConverter as none, noneAsNull, noneAsUndefined, noneable, noneableAsNull, noneableAsUndefined, NullConverter as null, NumberConverter as number, oneOf, optional, partial, record, select, shape, strict, StringConverter as string, sub, taggedUnion, UndefinedConverter as undefined, UnknownConverter as unknown };
//# sourceMappingURL=index.mjs.map
